/* IME101.cpp
 * (C) 2001 rcS
 */

#include <windows.h>
#include <windowsx.h>
#include <imm.h>
#include "resource.h"
#include "hook.h"

#define WM_TRAY  WM_USER+1

/* ^XNgCɒǉACR */
static NOTIFYICONDATA g_notifyicon;

/* ^XNg[ɃACRǉ */
void
AddIconToTray (HWND hWnd, PNOTIFYICONDATA ni)
{
  HICON hIcon;

  hIcon = LoadIcon (GetModuleHandle (NULL), MAKEINTRESOURCE (IDI_MAIN));
  ni->cbSize = sizeof (NOTIFYICONDATA);
  ni->hIcon  = hIcon;
  ni->hWnd   = hWnd;
  ni->uCallbackMessage = WM_TRAY;
  ni->uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
  ni->uID    = ID_MYTRAY;
  strcpy (ni->szTip, "IME101");

  Shell_NotifyIcon (NIM_ADD, ni);
}

/* ^XNg[ACR폜 */
void
DeleteIconFromTray (PNOTIFYICONDATA ni)
{
  Shell_NotifyIcon (NIM_DELETE, ni);
}

/* ^XNg[̃j[\ */
void
ShowTrayMenu (HWND hWnd)
{
  HMENU hMenu, hSubMenu;
  POINT pt;

  hMenu = LoadMenu (GetModuleHandle (NULL), MAKEINTRESOURCE (IDR_TRAYMENU));
  hSubMenu = GetSubMenu (hMenu, 0);
  GetCursorPos (&pt);
  SetForegroundWindow (hWnd);
  TrackPopupMenu (hSubMenu, TPM_BOTTOMALIGN, pt.x, pt.y, 0, hWnd, NULL);
  DestroyMenu (hMenu);
}

/* bZ[W̏ */
LRESULT CALLBACK
WndProc (HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
  switch (msg)
    {
    case WM_CREATE:
      AddIconToTray (hWnd, &g_notifyicon);
      hook_keypress (hWnd);
      break;
    case WM_DESTROY:
      unhook_keypress ();
      DeleteIconFromTray (&g_notifyicon);
      PostQuitMessage (0);
      break;
    case WM_COMMAND:
      switch (LOWORD (wp))
        {
        case ID_CLOSE:
          DestroyWindow (hWnd);
          break;
        }
      break;
    case WM_TRAY:
      if (wp != ID_MYTRAY)
        break;
      switch (lp)
        {
        case WM_RBUTTONDOWN:
          ShowTrayMenu (hWnd);
          break;
        }
      break;
    default:
      return DefWindowProc (hWnd, msg, wp, lp);
    }
  return 0;
}

/* _~[EChE̐ */
int
CreateDummyWindow (HINSTANCE hInst)
{
  HWND hWnd;
  WNDCLASSEX wc;

  wc.cbSize         = sizeof (WNDCLASSEX);
  wc.style          = CS_HREDRAW | CS_VREDRAW;
  wc.lpfnWndProc    = WndProc;
  wc.cbClsExtra     = 0;
  wc.cbWndExtra     = 0;
  wc.hInstance      = hInst;
  wc.hIcon          = LoadIcon (NULL, MAKEINTRESOURCE (IDI_MAIN));
  wc.hCursor        = LoadCursor (NULL, IDC_ARROW);
  wc.hbrBackground  = (HBRUSH) GetStockObject (WHITE_BRUSH);
  wc.lpszMenuName   = NULL;
  wc.lpszClassName  = "DummyWindow";
  wc.hIconSm        = LoadIcon(hInst, MAKEINTRESOURCE (IDI_MAIN));
  RegisterClassEx (&wc);

  hWnd = CreateWindow ("DummyWindow",
                       "DummyWindow",
                       WS_OVERLAPPEDWINDOW,
                       CW_USEDEFAULT,
                       CW_USEDEFAULT,
                       CW_USEDEFAULT,
                       CW_USEDEFAULT,
                       NULL,
                       NULL,
                       hInst,
                       NULL);
  if (! hWnd)
    return 1;
  else
    return 0;
}

int WINAPI
WinMain (HINSTANCE hInst, HINSTANCE hPreInst, LPSTR lpsCmdLine, int nCmdShow)
{
  MSG msg;

  if (CreateDummyWindow (hInst))
    {
      MessageBox (NULL, "EChE̐Ɏs܂B", "*** INTERNAL ERROR ***", MB_ICONERROR);
      return 1;
    }

  while (GetMessage (&msg, NULL, 0, 0))
    {
      TranslateMessage (&msg);
      DispatchMessage (&msg);
    }
  return msg.wParam;
}
