/*
 *	hook.cpp
 */

#include <windows.h>
#include <imm.h>
#include "hook.h"

static HANDLE g_module;
static HHOOK g_hook;
static HWND g_callback_wnd;

LRESULT CALLBACK hookproc_keypress (int, WPARAM, LPARAM);

BOOL APIENTRY
DllMain (HANDLE module, DWORD reason, LPVOID reserved)
{
  switch (reason)
    {
    case DLL_PROCESS_ATTACH:
      g_module = module;
      break;
    case DLL_THREAD_ATTACH:
    case DLL_THREAD_DETACH:
    case DLL_PROCESS_DETACH:
      break;
    }
  return TRUE;
}


DllExport void
hook_keypress (HWND callback)
{
  if (! g_hook)
    {
      g_hook = SetWindowsHookEx (WH_KEYBOARD, hookproc_keypress, (HINSTANCE) g_module, 0);
      g_callback_wnd = callback;
    }
}


DllExport void
unhook_keypress (void)
{
  if (g_hook)
    {
      UnhookWindowsHookEx (g_hook);
      g_hook = NULL;
    }
}

LRESULT CALLBACK
hookproc_keypress (int code, WPARAM wParam, LPARAM lParam)
{
  if (code < 0)
    goto next;
 
  if( GetAsyncKeyState(VK_SHIFT) & 0x10000000  // shift pressed
      && wParam == VK_SPACE )  // space key
    {
      if( lParam & (1<<30) )
        {
          // on key press
          ImmSimulateHotKey( GetForegroundWindow(), IME_JHOTKEY_CLOSE_OPEN );
        }
      return 1;
    }

 next:
  return CallNextHookEx (g_hook, code, wParam, lParam);
}
